unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.CheckLst,SetupAPI,ShellAPI;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function CM_Get_DevNode_Status(pulStatus: PULong; pulProblemNumber: PULong;
  dnDevInst: DWord; ulFlags: ULong): DWord; stdcall;
  external 'cfgmgr32.dll' name 'CM_Get_DevNode_Status';

const
  GUID_DEVCLASS_NET: TGUID = '{4D36E978-E325-11CE-BFC1-08002BE10318}';
  CR_SUCCESS                = $00000000;

procedure TForm1.FormCreate(Sender: TObject);
function GetRegistryProperty(PnPHandle: hDevInfo; DevData: TSPDevInfoData; Prop: DWord; Buffer: PChar; dwLength: DWord): Boolean;
var
  aBuffer: array[0..256] of Char;
begin
  dwLength := 0;
  aBuffer[0] := #0;
  SetupDiGetDeviceRegistryProperty(PnPHandle, DevData, Prop, Prop, PBYTE(@aBuffer[0]), SizeOf(aBuffer), dwLength);
  StrCopy(Buffer, aBuffer);
  Result := Buffer^ <> #0;
end;

function EnumAddDevices(DevInfo: hDevInfo): Boolean;
var
  i, Status, Problem: DWord;
  pszText: PChar;
  DeviceInfoData: TSPDevInfoData;
begin
  DeviceInfoData.cbSize := SizeOf(TSPDevInfoData);
  i := 0;
  // Enumerate though all the devices.
  while SetupDiEnumDeviceInfo(DevInfo, i, DeviceInfoData) do
  begin
    inc(i);
    // Should we display this device, or move onto the next one.
    if (CM_Get_DevNode_Status(@Status, @Problem, DeviceInfoData.DevInst, 0) <> CR_SUCCESS) then
    begin
      break;
    end;
    GetMem(pszText, 256);
    try
      // Get a friendly name for the device.
      GetRegistryProperty(DevInfo, DeviceInfoData, SPDRP_FRIENDLYNAME, pszText, DWord(nil));
      if length(pszText)<>0 then
        begin
          ListBox1.Items.Add(pszText);
        end;
    finally
      FreeMem(pszText);
    end;
  end;
  Result := true;
end;

var
  DevInfo: hDevInfo;
begin
  //Load DLL
  if (not LoadSetupAPI) then
  begin
    ShowMessage('Could not load SetupAPI.dll');
    exit;
  end;

  DevInfo := SetupDiGetClassDevs(@GUID_DEVCLASS_NET, nil, 0, DIGCF_PRESENT);
  if (DevInfo = Pointer(INVALID_HANDLE_VALUE)) then
  begin
    ShowMessage('GetClassDevs Fail!');
    exit;
  end;

  EnumAddDevices(DevInfo);
  //Unload DLL
  UnloadSetupApi;

end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  SerialPort:string;
  sc:integer;
begin
  if ListBox1.ItemIndex=-1 then exit;
  SerialPort:=Listbox1.Items[ListBox1.ItemIndex];
  if Pos('COM',SerialPort)=0 then
    begin
      ShowMessage('Please choose COM port.');
      exit;
    end;
  delete(SerialPort,1,pos('COM',SerialPort)-1);
  SerialPort:=copy(SerialPort,1,pos(')',SerialPort)-1);
  //showmessage(SerialPort);
  sc:=ShellExecute(handle, 'open',PChar('puttytel.exe'),PChar('-serial '+SerialPort+' -sercfg 115200,8,n,1,N'),nil, SW_SHOWNORMAL);
  case sc of
    0:ShowMessage('The operating system is out of memory or resources.');
    ERROR_FILE_NOT_FOUND:ShowMessage('The specified file was not found.');
    ERROR_PATH_NOT_FOUND:ShowMessage('The specified path was not found.');
    ERROR_BAD_FORMAT:ShowMessage('The .exe file is invalid (non-Win32 .exe or error in .exe image).');
    SE_ERR_ACCESSDENIED:ShowMessage('The operating system denied access to the specified file.');
    SE_ERR_ASSOCINCOMPLETE:ShowMessage('The file name association is incomplete or invalid.');
    SE_ERR_DDEBUSY:ShowMessage('The DDE transaction could not be completed because other DDE transactions were being processed.');
    SE_ERR_DDEFAIL:ShowMessage('The DDE transaction failed.');
    SE_ERR_DDETIMEOUT:ShowMessage('The DDE transaction could not be completed because the request timed out.');
    SE_ERR_DLLNOTFOUND:ShowMessage('The specified DLL was not found.');
    SE_ERR_NOASSOC:ShowMessage('There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable.');
    SE_ERR_OOM:ShowMessage('There was not enough memory to complete the operation.');
    SE_ERR_SHARE:ShowMessage('A sharing violation occurred.');
  end;
  Application.Terminate;
end;

end.

